package jmunit.framework.cldc11;

import j2meunit.midletui.TestRunner;
import jmunit.framework.cldc11.mocks.MockTest;
import jmunit.framework.cldc11.mocks.MockTestCase;
import jmunit.framework.cldc11.mocks.MockTestRunner;

import com.hammingweight.hammock.CompositeHandler;

public class AllTestsRunner extends TestRunner {

	// We sometimes a mock Test object. Since Test extends MIDlet we need to
	// create the mock in the constructor of the MIDlet that's running.
	public static MockTest mockTest;

	// Another mock test.
	public static MockTest mockTest2;

	// We need to test the behaviour of the TestCase class. We create a dummy
	// TestCase with three tests.
	public static MockTestCase testCase;

	// We need to test the behaviour of the TestSuite class.
	public static TestSuite testSuite;

	// We need to test the behaviour of the (abstract) TestRunner class.
	public static MockTestRunner testRunner;

	public AllTestsRunner() {
		// If our mock is ever asked how many tests it contains it'll say 3.
		CompositeHandler handler = new CompositeHandler();
		handler.addMethodHandler(MockTest.MTHD_COUNT_TEST_CASES)
				.setReturnValue(new Integer(3)).setNumberInvocations(0, 1000);
		mockTest = new MockTest("MockTest", handler);
		mockTest2 = new MockTest("MockTest2", handler);

		// Create the testCase in the constructor.
		testCase = new MockTestCase(3, "testcase", handler);

		// Create the TestSuite.
		testSuite = new TestSuite();

		// Create the TestRunner.
		handler.addMethodHandler(MockTestRunner.MTHD_GET_NESTED_TEST)
				.setReturnValue(mockTest2).setNumberInvocations(0, 1000);
		testRunner = new MockTestRunner(0, handler);
	}

	public void startApp() {
		start(new String[] { "jmunit.framework.cldc11.AssertionTest",
				"jmunit.framework.cldc11.TestResultTest",
				"jmunit.framework.cldc11.TestCaseTest",
				"jmunit.framework.cldc11.TestSuiteTest",
				"jmunit.framework.cldc11.TestRunnerTest",
				"jmunit.framework.cldc11.TestCasePerfTest",
				"jmunit.framework.cldc11.TimedMeasurementTest",
				"jmunit.framework.cldc11.MemoryMeasurementTest" });
	}

}
